(* Exemple d'un triangle avec son cercle circonscrit, son cercle
inscrit, ses trois cercles exinscrits, une droite de Simpson obtenue
en projetant un point du cercle circonscrit sur les trois cotes du
triangle *)

#open "euclide";;
#open "graphics";;

let triangle () =
 let gauche = -2.
 and droite = 2.
 and bas = -2.
 and haut = 2. in
 let m1 = random_point 0. (droite /. 2.) 0. (haut /. 2.)
 and m2 = random_point (gauche /. 2.) 0. 0. (haut /. 2.)
 and m3 = random_point (gauche /. 2.) 0. (bas /. 2.) 0. in
 let m1m2 = m1 *? m2
 and m2m3 = m2 *? m3
 and m3m1 = m3 *? m1
 and t = triangle m1 m2 m3 in
 let c = cercle_inscrit t
 and c1 = cercles_exinscrits t
 and c2 = cercle_circonscrit t in
 let m = point_objet c2 (random__float 2.) in
 let p1 = projection m m1m2
 and p2 = projection m m2m3
 and p3 = projection m m3m1 in
 let p1p2 = p1 *? p2 in
 fenetre " 400x400" gauche droite bas haut;
 dessine
  [Couleur red; m1m2; m2m3; m3m1;
   Couleur blue; c; c1.(1); c1.(2); c1.(0);
   Couleur green; c2;
   Couleur yellow; p1p2;
   Couleur black; p1; p2; p3; m1; m2; m3];;
